diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 40213daea..7b02ffd9b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.terrain;
 
 import java.util.HashSet;
 import java.util.List;
+import java.util.Objects;
 import java.util.Set;
 
 import net.minecraft.client.render.TileEntityRenderDispatcher;
@@ -9,21 +10,36 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ChunkRendererMultiDraw extends ChunkRenderer {
-    private static final @NotNull TessellatorTerrainImpl tessellatorTerrain = new TessellatorTerrainImpl(0x200000);
-    public final TerrainRendererMultiDraw terrainRenderer;
-    public final Entry[] renderListEntries;
-
-    public ChunkRendererMultiDraw(@NotNull TerrainRendererMultiDraw terrainRenderer, @NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
+    private static final @NotNull TessellatorTerrainImpl TESSELLATOR = new TessellatorTerrainImpl(0x200000);
+
+    public final @Nullable Entry<TessellatorTerrainImpl.TerrainVertexConfig> @NotNull [] renderListEntries;
+
+    private final @NotNull TerrainRendererMultiDraw terrainRenderer;
+    private final @NotNull TilePos min = new TilePos();
+    private final @NotNull TilePos max = new TilePos();
+    private final @NotNull TilePos cacheMin = new TilePos();
+    private final @NotNull TilePos cacheMax = new TilePos();
+
+    public ChunkRendererMultiDraw(
+        final @NotNull TerrainRendererMultiDraw terrainRenderer,
+        final @NotNull World world,
+        final @NotNull List<@NotNull TileEntity> globalRenderableTileEntities,
+        final int x, final int y, final int z,
+        final int size
+    ) {
         super(world, globalRenderableTileEntities, x, y, z, size);
 
         this.terrainRenderer = terrainRenderer;
@@ -31,24 +47,24 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
     }
 
     @Override
-    public boolean rebuild(boolean priority) {
-        if (!this.dirty) {
+    public boolean rebuild(final boolean priority) {
+        if (!this.isDirty()) {
             return false;
         }
 
-        final int minX = this.posX;
-        final int minY = this.posY;
-        final int minZ = this.posZ;
+        this.min.set(this.pos);
+        this.max.set(this.pos).add(this.size);
 
-        final int maxX = this.posX + this.sizeX;
-        final int maxY = this.posY + this.sizeY;
-        final int maxZ = this.posZ + this.sizeZ;
+        final int cacheRadius = 1;
+        this.cacheMin.set(this.min).sub(cacheRadius, cacheRadius, cacheRadius);
+        this.cacheMax.set(this.max).add(cacheRadius, cacheRadius, cacheRadius);
 
-        final int renderPassCount = this.terrainRenderer.MAX_RENDER_PASSES;
+        final int renderPassCount = TerrainRendererMultiDraw.MAX_RENDER_PASSES;
 
-        final int cacheRadius = 1;
-        final ChunkCache chunkCache = new ChunkCache(this.world, new TilePos(minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius), new TilePos(maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius), priority);
-        if (!chunkCache.allLoaded()) return false;
+        final ChunkCache chunkCache = new ChunkCache(this.getWorld(), this.cacheMin, this.cacheMax, priority);
+        if (!chunkCache.allLoaded()) {
+            return false;
+        }
 
         this.terrainRenderer.chunkDeleted(this);
         Chunk.isLit = false;
@@ -57,23 +73,22 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 
         updates++;
 
-        TessellatorTerrainImpl tessellator = tessellatorTerrain;
+        final @NotNull TilePos pos = new TilePos(0, 0, 0);
         for (int renderPass = 0; renderPass < renderPassCount; renderPass++) {
             boolean needsMoreRenderPasses = false;
             boolean hasRenderedBlock = false;
             boolean hasStartedDrawing = false;
 
-            TilePos pos = new TilePos(0, 0, 0);
-            for (pos.y = minY; pos.y < maxY; pos.y++) {
-                for (pos.z = minZ; pos.z < maxZ; pos.z++) {
-                    for (pos.x = minX; pos.x < maxX; pos.x++) {
+            for (pos.y = this.min.y; pos.y < this.max.y; pos.y++) {
+                for (pos.z = this.min.z; pos.z < this.max.z; pos.z++) {
+                    for (pos.x = this.min.x; pos.x < this.max.x; pos.x++) {
                         final @NotNull Block<?> block = chunkCache.getBlockType(pos);
                         if (!hasStartedDrawing) {
                             hasStartedDrawing = true;
-                            tessellator.startDrawingQuads();
+                            TESSELLATOR.startDrawingQuads();
 
-                            RenderRegion region = this.terrainRenderer.getRenderRegionAtBlockPos(this.posX, this.posZ);
-                            tessellator.setTranslation(-(region.posX << this.terrainRenderer.REGION_SIZE), 0.0, -(region.posZ << this.terrainRenderer.REGION_SIZE));
+                            final RenderRegion region = this.terrainRenderer.getRenderRegionAtBlockPos(this.pos.x, this.pos.z);
+                            TESSELLATOR.setTranslation(-(region.posX << TerrainRendererMultiDraw.REGION_SIZE), 0.0, -(region.posZ << TerrainRendererMultiDraw.REGION_SIZE));
                         }
                         if (renderPass == 0 && block.isEntityTile()) {
                             final TileEntity tileentity = chunkCache.getTileEntity(pos);
@@ -89,13 +104,13 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
                             continue;
                         }
 
-                        hasRenderedBlock |= renderBlock(tessellator, chunkCache, model, pos);
+                        hasRenderedBlock |= this.renderBlock(chunkCache, model, pos);
                     }
                 }
             }
             if (hasStartedDrawing) {
-                this.terrainRenderer.chunkRendered(this, tessellator, renderPass);
-                tessellator.setTranslation(0.0, 0.0, 0.0);
+                this.terrainRenderer.chunkRendered(this, TESSELLATOR, renderPass);
+                TESSELLATOR.setTranslation(0.0, 0.0, 0.0);
             } else {
                 hasRenderedBlock = false;
             }
@@ -108,19 +123,18 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
             }
         }
 
-        HashSet<TileEntity> newSpecialTileEntities = new HashSet<>(this.renderableBlockEntities);
+        final HashSet<TileEntity> newSpecialTileEntities = new HashSet<>(this.renderableBlockEntities);
         newSpecialTileEntities.removeAll(lastSpecialTileEntities);
         this.globalRenderableBlockEntities.addAll(newSpecialTileEntities);
         this.renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
         this.globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
-        this.skyLit = Chunk.isLit;
         this.compiled = true;
         return true;
     }
 
     @Override
-    public void cull(CameraFrustum frustum, float partialTick) {
-        boolean wasVisible = this.visible;
+    public void cull(final @NotNull CameraFrustum frustum, final float partialTick) {
+        final boolean wasVisible = this.visible;
         super.cull(frustum, partialTick);
         if (wasVisible != this.visible) {
             this.terrainRenderer.chunkVisibilityChanged(this);
@@ -129,15 +143,20 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 
     @Override
     public void reset() {
-        // TerrainRenderer is null during initialization
-        if (this.terrainRenderer != null) {
-            this.terrainRenderer.chunkDeleted(this);
-        }
+        this.terrainRenderer.chunkDeleted(this);
         super.reset();
     }
 
     @Override
     public String toString() {
-        return "[" + this.posX + "," + this.posY + "," + this.posZ + "]";
+        return "[" + this.pos.x + "," + this.pos.y + "," + this.pos.z + "]";
+    }
+
+    protected boolean renderBlock(final @NotNull WorldSource worldSource, final @NotNull BlockModel<?> model, final @NotNull TilePos tilePos) {
+        TESSELLATOR.setLightmapCoord2i(15, 15);
+        TESSELLATOR.setColor4i(255, 255, 255, 255);
+        TESSELLATOR.setTextureUV(0.0, 0.0);
+        TESSELLATOR.setShade1i(0xFF);
+        return model.render(TESSELLATOR, worldSource, tilePos);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
index 5b11603b8..a36419034 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
@@ -3,6 +3,10 @@ package net.minecraft.client.render.terrain;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.jetbrains.annotations.UnmodifiableView;
 
 import java.util.ArrayList;
 import java.util.Collections;
@@ -10,62 +14,62 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-public class RegionBuffer {
-	
-	public final int regionSizeShift;
-	
-	private final Int2ObjectMap<RenderRegion> regionMap = new Int2ObjectOpenHashMap<>();
-	private final List<RenderRegion> regionList = new ArrayList<>();
-	private final List<RenderRegion> immutableRegionList = Collections.unmodifiableList(regionList);
-	
-	public RegionBuffer(int regionSizeShift) {
-		this.regionSizeShift = regionSizeShift;
-	}
-	
-	public RenderRegion getRegionAtBlockPos(int blockX, int blockZ) {
-		int x = blockX >> regionSizeShift;
-		int z = blockZ >> regionSizeShift;
-		return getRegion(x, z);
-	}
-	
-	public RenderRegion getRegion(int x, int z) {
-		int index = getIndex(x, z);
-		
-		RenderRegion region = regionMap.get(index);
-		if(region == null) {
-			region = new RenderRegion(x, z);
-			regionMap.put(index, region);
-			regionList.add(region);
-		}else {
-			if(region.posX != x || region.posZ != z) {
-				throw new RuntimeException(region + " != " + new RenderRegion(x, z));
-			}	
-		}
-		return region;
-	}
-	
-	public void remove(RenderRegion region) {
-		int index = getIndex(region.posX, region.posZ);
-		
-		RenderRegion existingRegion = regionMap.get(index);
-		if(existingRegion != region) {
-			throw new RuntimeException(region + " != " + existingRegion);
-		}
-		
-		regionMap.remove(index);
-		regionList.remove(region);
-	}
-	
-	public int getIndex(int x, int z) {
-		return ((x & 0xFFFF) << 16) | (z & 0xFFFF);
-	}
-	
-	public List<RenderRegion> getAllRegions() {
-		return immutableRegionList;
-	}
-	
-	public int size() {
-		return regionMap.size();
-	}
-	
+public class RegionBuffer<V extends VertexConfig<V>> {
+    private final @NotNull Int2ObjectMap<@NotNull RenderRegion<V>> regionMap = new Int2ObjectOpenHashMap<>();
+    private final @NotNull List<@NotNull RenderRegion<V>> regionList = new ArrayList<>();
+    private final @NotNull @UnmodifiableView List<@NotNull RenderRegion<V>> immutableRegionList = Collections.unmodifiableList(this.regionList);
+
+    private final int regionSizeShift;
+
+    public RegionBuffer(final int regionSizeShift) {
+        this.regionSizeShift = regionSizeShift;
+    }
+
+    public @NotNull RenderRegion<V> getRegionAtBlockPos(final int blockX, final int blockZ) {
+        final int x = blockX >> this.regionSizeShift;
+        final int z = blockZ >> this.regionSizeShift;
+        return this.getRegion(x, z);
+    }
+
+    public @NotNull RenderRegion<V> getRegion(final int x, final int z) {
+        final int index = this.getIndex(x, z);
+
+        @Nullable RenderRegion<V> region = this.regionMap.get(index);
+        if (region == null) { // can be null despite what IntelliJ says
+            region = new RenderRegion<>(x, z);
+            this.regionMap.put(index, region);
+            this.regionList.add(region);
+        } else {
+            if (region.posX != x || region.posZ != z) {
+                throw new RuntimeException(region + " != " + new RenderRegion<>(x, z));
+            }
+        }
+
+        return region;
+    }
+
+    public void remove(final @NotNull RenderRegion<V> region) {
+        final int index = this.getIndex(region.posX, region.posZ);
+
+        final @Nullable RenderRegion<V> existingRegion = this.regionMap.get(index);
+        if (existingRegion != region) {
+            throw new RuntimeException(region + " != " + existingRegion);
+        }
+
+        this.regionMap.remove(index);
+        this.regionList.remove(region);
+    }
+
+    public int getIndex(final int x, final int z) {
+        return ((x & 0xFFFF) << 16) | (z & 0xFFFF);
+    }
+
+    public @NotNull @UnmodifiableView List<@NotNull RenderRegion<V>> getAllRegions() {
+        return this.immutableRegionList;
+    }
+
+    public int size() {
+        return this.regionMap.size();
+    }
+
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
index cea334730..9325695f4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -3,40 +3,37 @@ package net.minecraft.client.render.terrain;
 import static org.lwjgl.opengl.GL41.*;
 
 import java.nio.IntBuffer;
-import java.util.ArrayList;
-import java.util.HashSet;
-import java.util.List;
-import java.util.Set;
+import java.util.*;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
-import net.minecraft.core.Global;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.BufferUtils;
 
 /**
- * 		Can render a lot of objects with a single call
- * <br> All objects need to have the same {@link VertexConfigStandard}
+ * Can render a lot of objects with a single call
+ * <br> All objects need to have the same {@link VertexConfig}
  * <br> Entries can be toggled visible or invisible quickly
  */
-public class RenderList {
+public class RenderList<V extends VertexConfig<V>> {
     private static final CategorizedLogger LOGGER = LogUtils.getLogger();
 
-    public final VertexBuffer vertexBuffer;
+    private final @NotNull V vertexConfig;
+    private final @NotNull VertexBuffer vertexBuffer;
 
-    private VertexConfig<?> vertexConfig;
-    private boolean vertexConfigLocked = false;
+    private final @NotNull List<@NotNull Entry<V>> entryList = new ArrayList<>();
+    private final @NotNull Set<@NotNull Entry<V>> visibleEntries = new HashSet<>();
 
-    private IntBuffer posBuffer;
-    private IntBuffer sizeBuffer;
-
-    private final List<Entry> entryList = new ArrayList<>();
-    private final Set<Entry> visibleEntries = new HashSet<>();
+    private @NotNull IntBuffer sizeBuffer;
+    private @NotNull IntBuffer posBuffer;
 
     private boolean visibleEntriesUpdated = true;
 
-    public RenderList(VertexBuffer vertexBuffer, int capacity) {
+    public RenderList(final @NotNull VertexBuffer vertexBuffer, final @NotNull V vertexConfig, final int capacity) {
         this.vertexBuffer = vertexBuffer;
+        this.vertexConfig = vertexConfig;
         this.posBuffer = BufferUtils.createByteBuffer(capacity * 4).asIntBuffer();
         this.sizeBuffer = BufferUtils.createByteBuffer(capacity * 4).asIntBuffer();
     }
@@ -48,7 +45,7 @@ public class RenderList {
         }
 
         if (this.visibleEntriesUpdated) {
-            int vertexSize = this.vertexConfig.getVertexSize();
+            final int vertexSize = this.vertexConfig.getVertexSize();
 
             this.posBuffer = expandIfNecessary(this.posBuffer, this.visibleEntries.size());
             this.sizeBuffer = expandIfNecessary(this.sizeBuffer, this.visibleEntries.size());
@@ -56,9 +53,9 @@ public class RenderList {
             this.posBuffer.clear();
             this.sizeBuffer.clear();
 
-            for (Entry entry : this.visibleEntries) {
-                int pos = (int) (entry.position / vertexSize);
-                int size = (int) (entry.size / vertexSize);
+            for (final @NotNull Entry<V> entry : this.visibleEntries) {
+                final int pos = (int) (entry.position / vertexSize);
+                final int size = (int) (entry.size / vertexSize);
                 assert pos >= 0 : "Entry pos must be positive!";
                 assert size >= 0 : "Entry size must be positive!";
                 this.posBuffer.put(pos);
@@ -77,21 +74,15 @@ public class RenderList {
         }
 
 //		System.out.println("Rendering " + visibleEntries.size() + " entries");
-        glMultiDrawArrays(this.vertexConfig.drawmode().cap, this.posBuffer, this.sizeBuffer);
+        glMultiDrawArrays(this.vertexConfig.drawMode().cap, this.posBuffer, this.sizeBuffer);
     }
 
-    public Entry add(VertexData vertexData, boolean visible) {
+    public @Nullable Entry<V> add(final @NotNull VertexData<V> vertexData, final boolean visible) {
         if (vertexData.vertexCount <= 0) {
             return null;
         }
 
-        if (this.entryList.isEmpty() && !this.vertexConfigLocked) {
-            this.vertexConfig = vertexData.config.copy();
-        } else {
-            VertexConfigStandard.compareThrow(this.vertexConfig, vertexData.config);
-        }
-
-        Entry entry = this.vertexBuffer.addVertexData(vertexData);
+        final @NotNull Entry<V> entry = Objects.requireNonNull(this.vertexBuffer.addVertexData(vertexData));
         this.entryList.add(entry);
 
         if (visible) {
@@ -102,10 +93,7 @@ public class RenderList {
         return entry;
     }
 
-    public void setVisible(Entry entry, boolean visible) {
-        if (entry == null) {
-            throw new NullPointerException();
-        }
+    public void setVisible(final @NotNull Entry<V> entry, final boolean visible) {
         if (visible) {
             if (this.visibleEntries.add(entry)) {
                 this.visibleEntriesUpdated = true;
@@ -117,18 +105,7 @@ public class RenderList {
         }
     }
 
-    public void lockVertexConfig(VertexConfigStandard vertexConfig) {
-        if (vertexConfig == null) {
-            throw new NullPointerException("VertexConfig cannot be null!");
-        }
-        if (!this.entryList.isEmpty() && !this.vertexConfig.equals(vertexConfig)) {
-            VertexConfigStandard.compareThrow(this.vertexConfig, vertexConfig);
-        }
-        this.vertexConfig = vertexConfig.copy();
-        this.vertexConfigLocked = true;
-    }
-
-    public boolean remove(Entry entry) {
+    public boolean remove(final @NotNull Entry<V> entry) {
         if (this.entryList.remove(entry)) {
             this.vertexBuffer.removeEntry(entry);
             this.visibleEntries.remove(entry);
@@ -146,17 +123,13 @@ public class RenderList {
         return this.visibleEntries.size();
     }
 
-    public VertexConfig<?> getVertexConfig() {
+    public @NotNull V getVertexConfig() {
         return this.vertexConfig;
     }
 
-    public boolean isVertexConfigLocked() {
-        return this.vertexConfigLocked;
-    }
-
-    public static IntBuffer expandIfNecessary(IntBuffer buffer, int requiredCapacity) {
+    private static @NotNull IntBuffer expandIfNecessary(final @NotNull IntBuffer buffer, final int requiredCapacity) {
         if (buffer.capacity() < requiredCapacity) {
-            int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
+            final int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
 
             LOGGER.warn("Expanding RenderList IntBuffer from {} to {} ints...", buffer.capacity(), newCapacity);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java
index 5a1d2f619..206e143a6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java
@@ -1,30 +1,23 @@
 package net.minecraft.client.render.terrain;
 
-public class RenderRegion {
-	
-	public final int posX;
-	public final int posZ;
-	
-	public RenderList[] renderLists = new RenderList[2];
-	
-	public RenderRegion(int posX, int posZ) {
-		this.posX = posX;
-		this.posZ = posZ;
-	}
-	
-	public boolean hasRenderData() {
-		for(int i=0; i < renderLists.length; i++) {
-			RenderList renderList = renderLists[i];
-			if(renderList != null && renderList.size() > 0) {
-				return true;
-			}
-		}
-		return false;
-	}
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class RenderRegion<V extends VertexConfig<V>> {
+
+    public final int posX;
+    public final int posZ;
+
+    public final @Nullable RenderList<V> @NotNull [] renderLists = new RenderList[2];
+
+    public RenderRegion(final int posX, final int posZ) {
+        this.posX = posX;
+        this.posZ = posZ;
+    }
+
+    @Override
+    public String toString() {
+        return "[" + this.posX + "," + this.posZ + "]";
+    }
 
-	@Override
-	public String toString() {
-		return "[" + posX + "," + posZ + "]";
-	}
-	
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
index bfafe0bfb..cff4b9765 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
@@ -5,12 +5,13 @@ import java.util.List;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class TerrainRenderer {
 	
-	public final Minecraft mc;
+	public final @NotNull Minecraft mc;
 	
-	public TerrainRenderer(Minecraft minecraft) {
+	public TerrainRenderer(final @NotNull Minecraft minecraft) {
 		this.mc = minecraft;
 	}
 	
@@ -18,6 +19,11 @@ public abstract class TerrainRenderer {
 	
 	public abstract void renderTranslucentTerrain(float partialTicks);
 	
-	public abstract ChunkRenderer createChunkRenderer(World world, List<TileEntity> globalRenderableTileEntities, int x, int y, int z, int size);
+	public abstract @NotNull ChunkRenderer createChunkRenderer(
+		@NotNull World world,
+		@NotNull List<@NotNull TileEntity> globalRenderableTileEntities,
+		int x, int y, int z,
+		int size
+	);
 
 }
